Index: pjproject/trunk/pjmedia/include/pjmedia/session.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/session.h	(revision 158)
+++ pjproject/trunk/pjmedia/include/pjmedia/session.h	(revision 159)
@@ -26,6 +26,5 @@
  */
 
-#include <pj/types.h>
-#include <pjmedia/mediamgr.h>
+#include <pjmedia/endpoint.h>
 #include <pjmedia/stream.h>
 #include <pjmedia/sdp.h>
@@ -39,107 +38,138 @@
  */
 
-/** Opaque declaration of media session. */
-typedef struct pj_media_session_t pj_media_session_t;
-
-/** Media socket info. */
-typedef struct pj_media_sock_info
-{
-    pj_sock_t	    rtp_sock, rtcp_sock;
-    pj_sockaddr_in  rtp_addr_name;
-} pj_media_sock_info;
-
-/** Stream info. */
-typedef struct pj_media_stream_info
-{
-    pj_str_t		type;
-    pj_media_dir_t	dir;
-    pj_str_t		transport;
-    pj_media_sock_info	sock_info;
-    pj_str_t		rem_addr;
-    unsigned short	rem_port;
-    unsigned		fmt_cnt;
-    pj_codec_id		fmt[PJSDP_MAX_FMT];
-
-} pj_media_stream_info;
-
-/** Flag for modifying stream. */
-enum
-{
-    PJ_MEDIA_STREAM_MODIFY_DIR = 1,
-};
 
 /**
- * Create new session offering.
+ * Create new session offering based on the local and remote SDP.
+ * The session initially will be inactive.
+ *
+ * @param endpt		The PJMEDIA endpoint instance.
+ * @param stream_cnt	Maximum number of streams to be created. This
+ *			also denotes the number of elements in the
+ *			socket information.
+ * @param skinfo	Array of socket informations. The argument stream_cnt
+ *			specifies the number of elements in this array. One
+ *			element is needed for each media stream to be
+ *			created in the session.
+ * @param local_sdp	The SDP describing local capability.
+ * @param rem_sdp	The SDP describing remote capability.
+ * @param p_session	Pointer to receive the media session.
+ *
+ * @return		PJ_SUCCESS if media session can be created 
+ *			successfully.
  */
-PJ_DECL(pj_media_session_t*) 
-pj_media_session_create ( pj_med_mgr_t *mgr, const pj_media_sock_info *skinfo );
+PJ_DECL(pj_status_t) pjmedia_session_create( pjmedia_endpt *endpt, 
+					     unsigned stream_cnt,
+					     const pjmedia_sock_info skinfo[],
+					     const pjmedia_sdp_session *local_sdp,
+					     const pjmedia_sdp_session *rem_sdp,
+					     pjmedia_session **p_session );
+
 
 /**
- * Create new session based on peer's offering.
+ * Activate all streams in media session for the specified direction.
+ *
+ * @param session	The media session.
+ * @param dir		The direction to activate.
+ *
+ * @return		PJ_SUCCESS if success.
  */
-PJ_DECL(pj_media_session_t*) 
-pj_media_session_create_from_sdp ( pj_med_mgr_t *mgr, const pjsdp_session_desc *sdp,
-				   const pj_media_sock_info *skinfo);
+PJ_DECL(pj_status_t) pjmedia_session_resume(pjmedia_session *session,
+					    pjmedia_dir dir);
+
 
 /**
- * Duplicate session. The new session is inactive.
+ * Suspend receipt and transmission of all streams in media session
+ * for the specified direction.
+ *
+ * @param session	The media session.
+ * @param dir		The media direction to suspend.
+ *
+ * @return		PJ_SUCCESS if success.
  */
-PJ_DECL(pj_media_session_t*)
-pj_media_session_clone (const pj_media_session_t *session);
+PJ_DECL(pj_status_t) pjmedia_session_pause(pjmedia_session *session,
+					   pjmedia_dir dir);
 
 /**
- * Create SDP description from the session.
+ * Suspend receipt and transmission of individual stream in media session
+ * for the specified direction.
+ *
+ * @param session	The media session.
+ * @param index		The stream index.
+ * @param dir		The media direction to pause.
+ *
+ * @return		PJ_SUCCESS on success.
  */
-PJ_DECL(pjsdp_session_desc*)
-pj_media_session_create_sdp ( const pj_media_session_t *session, pj_pool_t *pool,
-			      pj_bool_t only_first_fmt);
+PJ_DECL(pj_status_t) pjmedia_session_pause_stream( pjmedia_session *session,
+						   unsigned index,
+						   pjmedia_dir dir);
 
 /**
- * Update session with SDP answer from peer. The session must NOT active.
+ * Activate individual stream in media session for the specified direction.
+ *
+ * @param session	The media session.
+ * @param index		The stream index.
+ * @param dir		The media direction to activate.
+ *
+ * @return		PJ_SUCCESS on success.
  */
-PJ_DECL(pj_status_t)
-pj_media_session_update ( pj_media_session_t *session, 
-			  const pjsdp_session_desc *sdp);
+PJ_DECL(pj_status_t) pjmedia_session_resume_stream(pjmedia_session *session,
+						   unsigned index,
+						   pjmedia_dir dir);
 
 /**
  * Enumerate media streams in the session.
- * @return the actual number of streams.
+ *
+ * @param session	The media session.
+ * @param count		On input, specifies the number of elements in
+ *			the array. On output, the number will be filled
+ *			with number of streams in the session.
+ * @param strm_info	Array of stream info.
+ *
+ * @return		PJ_SUCCESS on success.
  */
-PJ_DECL(unsigned)
-pj_media_session_enum_streams (const pj_media_session_t *session, 
-			       unsigned count, const pj_media_stream_info *info[]);
+PJ_DECL(pj_status_t) pjmedia_session_enum_streams(const pjmedia_session *session,
+						  unsigned *count, 
+						  pjmedia_stream_info strm_info[]);
+
 
 /**
- * Get stream statistics.
+ * Get session statistics. The stream statistic shows various
+ * indicators such as packet count, packet lost, jitter, delay, etc.
+ *
+ * @param session	The media session.
+ * @param count		On input, specifies the number of elements in
+ *			the array. On output, the number will be filled
+ *			with number of streams in the session.
+ * @param stat		Array of stream statistics.
+ *
+ * @return		PJ_SUCCESS on success.
  */
-PJ_DECL(pj_status_t)
-pj_media_session_get_stat (const pj_media_session_t *session, unsigned index,
-			   pj_media_stream_stat *tx_stat,
-			   pj_media_stream_stat *rx_stat);
+PJ_DECL(pj_status_t) pjmedia_session_get_stat(const pjmedia_session *session,
+					      unsigned *count,
+					      pjmedia_stream_stat stat[]);
 
 /**
- * Modify stream, only when stream is inactive.
+ * Get individual stream statistics. The stream statistic shows various
+ * indicators such as packet count, packet lost, jitter, delay, etc.
+ *
+ * @param s		The media session.
+ * @param index		The stream index.
+ * @param stat		Stream statistics.
+ *
+ * @return		PJ_SUCCESS on success.
  */
-PJ_DECL(pj_status_t)
-pj_media_session_modify_stream (pj_media_session_t *session, unsigned index,
-				unsigned modify_flag, const pj_media_stream_info *info);
-
-/**
- * Activate all streams in media session.
- */
-PJ_DECL(pj_status_t)
-pj_media_session_activate (pj_media_session_t *session);
-
-/**
- * Activate individual stream in media session.
- */
-PJ_DECL(pj_status_t)
-pj_media_session_activate_stream (pj_media_session_t *session, unsigned index);
+PJ_DECL(pj_status_t) pjmedia_session_get_stream_stat(const pjmedia_session *s,
+						     unsigned index,
+						     pjmedia_stream_stat *stat);
 
 /**
  * Destroy media session.
+ *
+ * @param session	The media session.
+ *
+ * @return		PJ_SUCCESS if success.
  */
-PJ_DECL(pj_status_t)
-pj_media_session_destroy (pj_media_session_t *session);
+PJ_DECL(pj_status_t) pjmedia_session_destroy(pjmedia_session *session);
+
 
 
Index: pjproject/trunk/pjmedia/include/pjmedia/stream.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/stream.h	(revision 158)
+++ pjproject/trunk/pjmedia/include/pjmedia/stream.h	(revision 159)
@@ -28,5 +28,5 @@
 #include <pjmedia/sound.h>
 #include <pjmedia/codec.h>
-#include <pjmedia/mediamgr.h>
+#include <pjmedia/endpoint.h>
 #include <pj/sock.h>
 
@@ -40,53 +40,122 @@
  */
 
-typedef struct pj_media_stream_t pj_media_stream_t;
+/**
+ * Opaque declaration for media channel.
+ * Media channel is unidirectional flow of media from sender to
+ * receiver.
+ */
+typedef struct pjmedia_channel pjmedia_channel;
 
-/** Parameter for creating channel. */
-typedef struct pj_media_stream_create_param
+/** 
+ * This structure describes media stream information. Each media stream
+ * corresponds to one "m=" line in SDP session descriptor, and it has
+ * its own RTP/RTCP socket pair.
+ */
+struct pjmedia_stream_info
 {
-    /** Codec ID, must NOT be NULL. */
-    pj_codec_id		 *codec_id;
+    pjmedia_type	type;	    /**< Media type (audio, video)	    */
+    pjmedia_dir		dir;	    /**< Media direction.		    */
+    pjmedia_sock_info	sock_info;  /**< Media transport (RTP/RTCP sockets) */
+    pj_sockaddr_in	rem_addr;   /**< Remote RTP address		    */
+    pjmedia_codec_info	fmt;	    /**< Codec format info.		    */
+    pj_uint32_t		ssrc;	    /**< RTP SSRC.			    */
+    int			jb_min;	    /**< Jitter buffer min delay.	    */
+    int			jb_max;	    /**< Jitter buffer max delay.	    */
+    int			jb_maxcnt;  /**< Jitter buffer max delay.	    */
+};
 
-    /** Media manager, must NOT be NULL. */
-    pj_med_mgr_t	 *mediamgr;
 
-    /** Direction: IN_OUT, or IN only, or OUT only. */
-    pj_media_dir_t	  dir;
+/**
+ * Individual channel statistic.
+ */
+struct pjmedia_channel_stat
+{
+    pj_uint32_t pkt;	    /**< Total number of packets.		    */
+    pj_uint32_t bytes;	    /**< Total number of bytes, including RTP hdr.  */
+    pj_uint32_t lost;	    /**< Total number of packet lost		    */
+};
 
-    /** RTP socket. */
-    pj_sock_t		 rtp_sock;
+/**
+ * Stream statistic.
+ */
+struct pjmedia_stream_stat
+{
+    pjmedia_channel_stat    enc;    /**< Encoder statistics.		    */
+    pjmedia_channel_stat    dec;    /**< Decoder statistics.		    */
+};
 
-    /** RTCP socket. */
-    pj_sock_t		 rtcp_sock;
 
-    /** Address of remote */
-    pj_sockaddr_in	 *remote_addr;
+/**
+ * Create a media stream based on the specified stream parameter.
+ * All channels in the stream initially will be inactive.
+ *
+ * @param endpt		Media endpoint.
+ * @param pool		Pool to allocate memory for the stream. A large
+ *			number of memory may be needed because jitter
+ *			buffer needs to preallocate some storage.
+ * @param info		Stream information.
+ * @param p_stream	Pointer to receive the media stream.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjmedia_stream_create(pjmedia_endpt *endpt,
+					   pj_pool_t *pool,
+					   const pjmedia_stream_info *info,
+					   pjmedia_stream **p_stream);
 
-    /** RTP SSRC */
-    pj_uint32_t		  ssrc;
+/**
+ * Destroy the media stream.
+ *
+ * @param stream	The media stream.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjmedia_stream_destroy(pjmedia_stream *stream);
 
-    /** Jitter buffer parameters. */
-    int			  jb_min, jb_max, jb_maxcnt;
+/**
+ * Start the media stream. This will start the appropriate channels
+ * in the media stream, depending on the media direction that was set
+ * when the stream was created.
+ *
+ * @param stream	The media stream.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjmedia_stream_start(pjmedia_stream *stream);
 
-} pj_media_stream_create_param;
 
-typedef struct pj_media_stream_stat
-{
-    pj_uint32_t pkt_tx, pkt_rx;	/* packets transmitted/received */
-    pj_uint32_t oct_tx, oct_rx;	/* octets transmitted/received */
-    pj_uint32_t jitter;		/* receive jitter in ms */
-    pj_uint32_t pkt_lost;	/* total packet lost count */
-} pj_media_stream_stat;
+/**
+ * Get the stream statistics.
+ *
+ * @param stream	The media stream.
+ * @param stat		Media stream statistics.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjmedia_stream_get_stat( const pjmedia_stream *stream,
+					      pjmedia_stream_stat *stat);
 
-PJ_DECL(pj_status_t) pj_media_stream_create (pj_pool_t *pool,
-					     pj_media_stream_t **enc_stream,
-					     pj_media_stream_t **dec_stream,
-					     pj_media_stream_create_param *param);
-PJ_DECL(pj_status_t) pj_media_stream_start (pj_media_stream_t *stream);
-PJ_DECL(pj_status_t) pj_media_stream_get_stat (const pj_media_stream_t *stream,
-					       pj_media_stream_stat *stat);
-PJ_DECL(pj_status_t) pj_media_stream_pause (pj_media_stream_t *stream);
-PJ_DECL(pj_status_t) pj_media_stream_resume (pj_media_stream_t *stream);
-PJ_DECL(pj_status_t) pj_media_stream_destroy (pj_media_stream_t *stream);
+/**
+ * Pause the individual channel in the stream.
+ *
+ * @param channel	The media channel.
+ * @param dir		Which direction to pause.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjmedia_stream_pause( pjmedia_stream *stream,
+					   pjmedia_dir dir);
+
+/**
+ * Resume the individual channel in the stream.
+ *
+ * @param channel	The media channel.
+ * @param dir		Which direction to resume.
+ *
+ * @return		PJ_SUCCESS on success;
+ */
+PJ_DECL(pj_status_t) pjmedia_stream_resume(pjmedia_stream *stream,
+					   pjmedia_dir dir);
+
 
 /**
Index: pjproject/trunk/pjmedia/include/pjmedia/types.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/types.h	(revision 158)
+++ pjproject/trunk/pjmedia/include/pjmedia/types.h	(revision 159)
@@ -21,5 +21,147 @@
 
 #include <pj/types.h>
-
+#include <pj/sock.h>
+
+
+/** 
+ * Top most media type. 
+ */
+enum pjmedia_type
+{
+    /** No type. */
+    PJMEDIA_TYPE_NONE = 0,
+
+    /** The media is audio */
+    PJMEDIA_TYPE_AUDIO = 1,
+
+    /** The media is video. */
+    PJMEDIA_TYPE_VIDEO = 2,
+
+    /** Unknown media type, in this case the name will be specified in 
+     *  encoding_name.
+     */
+    PJMEDIA_TYPE_UNKNOWN = 3,
+
+};
+
+
+/** 
+ * Media direction. 
+ */
+enum pjmedia_dir
+{
+    /** None */
+    PJMEDIA_DIR_NONE = 0,
+
+    /** Encoding (outgoing to network) stream */
+    PJMEDIA_DIR_ENCODING = 1,
+
+    /** Decoding (incoming from network) stream. */
+    PJMEDIA_DIR_DECODING = 2,
+
+    /** Incoming and outgoing stream. */
+    PJMEDIA_DIR_ENCODING_DECODING = 3,
+
+};
+
+
+/**
+ * Top level media type.
+ */
+typedef enum pjmedia_type pjmedia_type;
+
+/**
+ * Media direction.
+ */
+typedef enum pjmedia_dir pjmedia_dir;
+
+/**
+ * Codec info.
+ */
+typedef struct pjmedia_codec_info pjmedia_codec_info;
+
+/**
+ * Codec initialization parameter.
+ */
+typedef struct pjmedia_codec_param pjmedia_codec_param;
+
+/** 
+ * Types of media frames. 
+ */
+typedef enum pjmedia_frame_type pjmedia_frame_type;
+
+/** 
+ * This structure describes a media frame. 
+ */
+typedef struct pjmedia_frame pjmedia_frame;
+
+/**
+ * Codec instance.
+ */
+typedef struct pjmedia_codec pjmedia_codec;
+
+/**
+ * Codec factory.
+ */
+typedef struct pjmedia_codec_factory pjmedia_codec_factory;
+
+/**
+ * Codec operation.
+ */
+typedef struct pjmedia_codec_op pjmedia_codec_op;
+
+/**
+ * Codec factory operation.
+ */
+typedef struct pjmedia_codec_factory_op pjmedia_codec_factory_op;
+
+/**
+ * Codec manager.
+ */
+typedef struct pjmedia_codec_mgr pjmedia_codec_mgr;
+
+/** 
+ * Opague declaration of media endpoint. 
+ */
+typedef struct pjmedia_endpt pjmedia_endpt;
+
+
+/** 
+ * Media socket info. 
+ */
+typedef struct pjmedia_sock_info
+{
+
+    pj_sock_t	    rtp_sock;
+    pj_sock_t	    rtcp_sock;
+    pj_sockaddr_in  rtp_addr_name;
+
+} pjmedia_sock_info;
+
+
+/**
+ * Typedef for media stream information.
+ */
+typedef struct pjmedia_stream_info pjmedia_stream_info;
+
+/**
+ * Typedef for media stream statistic.
+ */
+typedef struct pjmedia_stream_stat pjmedia_stream_stat;
+
+/**
+ * Typedef for media stream.
+ */
+typedef struct pjmedia_stream pjmedia_stream;
+
+/**
+ * Individual channel statistic.
+ */
+typedef struct pjmedia_channel_stat pjmedia_channel_stat;
+
+/** 
+ * Opaque declaration of media session. 
+ */
+typedef struct pjmedia_session pjmedia_session;
 
 /**
Index: pjproject/trunk/pjmedia/src/pjmedia/codec.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/codec.c	(revision 158)
+++ pjproject/trunk/pjmedia/src/pjmedia/codec.c	(revision 159)
@@ -18,4 +18,5 @@
  */
 #include <pjmedia/codec.h>
+#include <pjmedia/errno.h>
 #include <pj/pool.h>
 #include <pj/string.h>
@@ -25,83 +26,136 @@
 #define THIS_FILE   "codec.c"
 
-static void enum_all_codecs (pj_codec_mgr *cm)
+/*
+ * Reinitialize array of supported codecs.
+ */
+static void enum_all_codecs (pjmedia_codec_mgr *mgr)
 {
-    pj_codec_factory *cf;
+    pjmedia_codec_factory *factory;
 
-    cf = cm->factory_list.next;
-    cm->codec_cnt = 0;
-    while (cf != &cm->factory_list) {
-	pj_codec_id temp[PJ_CODEC_MGR_MAX_CODECS];
-	int i, cnt;
+    mgr->codec_cnt = 0;
 
-	cnt = cf->op->enum_codecs (cf, PJ_CODEC_MGR_MAX_CODECS, temp);
-	if (cnt > PJ_CODEC_MGR_MAX_CODECS) {
-	    pj_assert(0);
-	    PJ_LOG(4, (THIS_FILE, "Too many codecs reported by factory"));
-	    cnt = PJ_CODEC_MGR_MAX_CODECS;
-	}
+    factory = mgr->factory_list.next;
+    while (factory != &mgr->factory_list) {
+	unsigned count;
+	pj_status_t status;
 
-	for (i=0; i<cnt && cm->codec_cnt < PJ_CODEC_MGR_MAX_CODECS; ++i) {
-	    cm->codecs[cm->codec_cnt++] = temp[i];
-	}
+	count = PJ_ARRAY_SIZE(mgr->codecs) - mgr->codec_cnt;
+	status = factory->op->enum_info(factory, &count, 
+					mgr->codecs+mgr->codec_cnt);
+	if (status == PJ_SUCCESS)
+	    mgr->codec_cnt += count;
 
-	cf = cf->next;
+	factory = factory->next;
     }
 }
 
-PJ_DEF(pj_status_t) pj_codec_mgr_init (pj_codec_mgr *mgr)
+/*
+ * Initialize codec manager.
+ */
+PJ_DEF(pj_status_t) pjmedia_codec_mgr_init (pjmedia_codec_mgr *mgr)
 {
+    PJ_ASSERT_RETURN(mgr, PJ_EINVAL);
+
     pj_list_init (&mgr->factory_list);
     mgr->codec_cnt = 0;
-    return 0;
+
+    return PJ_SUCCESS;
 }
 
-PJ_DEF(pj_status_t) pj_codec_mgr_register_factory (pj_codec_mgr *mgr,
-						   pj_codec_factory *factory)
+/*
+ * Register a codec factory.
+ */
+PJ_DEF(pj_status_t) 
+pjmedia_codec_mgr_register_factory( pjmedia_codec_mgr *mgr,
+				    pjmedia_codec_factory *factory)
 {
-    pj_list_insert_before (&mgr->factory_list, factory);
+    PJ_ASSERT_RETURN(mgr && factory, PJ_EINVAL);
+
+    pj_list_push_back(&mgr->factory_list, factory);
     enum_all_codecs (mgr);
-    return 0;
+
+    return PJ_SUCCESS;
 }
 
-PJ_DEF(void) pj_codec_mgr_unregister_factory (pj_codec_mgr *mgr, pj_codec_factory *factory)
+/*
+ * Unregister a codec factory.
+ */
+PJ_DEF(pj_status_t) 
+pjmedia_codec_mgr_unregister_factory(pjmedia_codec_mgr *mgr, 
+				     pjmedia_codec_factory *factory)
 {
-    PJ_UNUSED_ARG(mgr);
+
+    PJ_ASSERT_RETURN(mgr && factory, PJ_EINVAL);
+
+    /* Factory must be registered. */
+    PJ_ASSERT_RETURN(pj_list_find_node(&mgr->factory_list, factory)==factory,
+		     PJ_ENOTFOUND);
+
+
     pj_list_erase(factory);
     enum_all_codecs (mgr);
+
+    return PJ_SUCCESS;
 }
 
-PJ_DEF(unsigned)
-pj_codec_mgr_enum_codecs (pj_codec_mgr *mgr, unsigned count, const pj_codec_id *codecs[])
+/*
+ * Enum all codecs.
+ */
+PJ_DEF(pj_status_t)
+pjmedia_codec_mgr_enum_codecs(pjmedia_codec_mgr *mgr, 
+			      unsigned *count, 
+			      pjmedia_codec_info codecs[])
 {
-    unsigned i;
+    PJ_ASSERT_RETURN(mgr && count && codecs, PJ_EINVAL);
 
-    if (count > mgr->codec_cnt)
-	count = mgr->codec_cnt;
+    if (*count > mgr->codec_cnt)
+	*count = mgr->codec_cnt;
+    
+    pj_memcpy(codecs, mgr->codecs, *count * sizeof(pjmedia_codec_info));
 
-    for (i=0; i<count; ++i)
-	codecs[i] = &mgr->codecs[i];
-
-    return mgr->codec_cnt;
+    return PJ_SUCCESS;
 }
 
-PJ_DEF(pj_codec*) pj_codec_mgr_alloc_codec (pj_codec_mgr *mgr, const struct pj_codec_id *id)
+/*
+ * Allocate one codec.
+ */
+PJ_DEF(pj_status_t) pjmedia_codec_mgr_alloc_codec(pjmedia_codec_mgr *mgr, 
+						  const pjmedia_codec_info *info,
+						  pjmedia_codec **p_codec)
 {
-    pj_codec_factory *factory = mgr->factory_list.next;
+    pjmedia_codec_factory *factory;
+    pj_status_t status;
+
+    PJ_ASSERT_RETURN(mgr && info && p_codec, PJ_EINVAL);
+
+    *p_codec = NULL;
+
+    factory = mgr->factory_list.next;
     while (factory != &mgr->factory_list) {
-	if ( (*factory->op->match_id)(factory, id) == 0 ) {
-	    pj_codec *codec = (*factory->op->alloc_codec)(factory, id);
-	    if (codec != NULL)
-		return codec;
+
+	if ( (*factory->op->test_alloc)(factory, info) == PJ_SUCCESS ) {
+
+	    status = (*factory->op->alloc_codec)(factory, info, p_codec);
+	    if (status == PJ_SUCCESS)
+		return PJ_SUCCESS;
+
 	}
+
 	factory = factory->next;
     }
-    return NULL;
+
+
+    return PJMEDIA_CODEC_EUNSUP;
 }
 
-PJ_DEF(void) pj_codec_mgr_dealloc_codec (pj_codec_mgr *mgr, pj_codec *codec)
+/*
+ * Dealloc codec.
+ */
+PJ_DEF(pj_status_t) pjmedia_codec_mgr_dealloc_codec(pjmedia_codec_mgr *mgr, 
+						    pjmedia_codec *codec)
 {
-    PJ_UNUSED_ARG(mgr);
-    (*codec->factory->op->dealloc_codec)(codec->factory, codec);
+    PJ_ASSERT_RETURN(mgr && codec, PJ_EINVAL);
+
+    return (*codec->factory->op->dealloc_codec)(codec->factory, codec);
 }
 
Index: pjproject/trunk/pjmedia/src/pjmedia/endpoint.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/endpoint.c	(revision 159)
+++ pjproject/trunk/pjmedia/src/pjmedia/endpoint.c	(revision 159)
@@ -0,0 +1,239 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pjmedia/endpoint.h>
+#include <pjmedia/errno.h>
+#include <pjmedia/sdp.h>
+#include <pj/sock.h>
+#include <pj/pool.h>
+#include <pj/string.h>
+#include <pj/assert.h>
+#include <pj/os.h>
+
+
+#define THIS_FILE   "endpoint.c"
+
+static const pj_str_t STR_AUDIO = { "audio", 5};
+static const pj_str_t STR_VIDEO = { "video", 5};
+static const pj_str_t STR_IN = { "IN", 2 };
+static const pj_str_t STR_IP4 = { "IP4", 3};
+static const pj_str_t STR_RTP_AVP = { "RTP/AVP", 7 };
+static const pj_str_t STR_SDP_NAME = { "pjmedia", 7 };
+static const pj_str_t STR_SENDRECV = { "sendrecv", 8 };
+
+
+PJ_DECL(pj_status_t) g711_init_factory (pjmedia_codec_factory *factory, pj_pool_t *pool);
+PJ_DECL(pj_status_t) g711_deinit_factory (pjmedia_codec_factory *factory);
+
+
+/** Concrete declaration of media endpoint. */
+struct pjmedia_endpt
+{
+    /** Pool. */
+    pj_pool_t		 *pool;
+
+    /** Pool factory. */
+    pj_pool_factory	 *pf;
+
+    /** Codec manager. */
+    pjmedia_codec_mgr	  codec_mgr;
+};
+
+/**
+ * Initialize and get the instance of media endpoint.
+ */
+PJ_DEF(pj_status_t) pjmedia_endpt_create(pj_pool_factory *pf,
+					 pjmedia_endpt **p_endpt)
+{
+    pj_pool_t *pool;
+    pjmedia_endpt *endpt;
+    pjmedia_codec_factory *factory;
+    pj_status_t status;
+
+    PJ_ASSERT_RETURN(pf && p_endpt, PJ_EINVAL);
+
+    pool = pj_pool_create(pf, "med-ept", 512, 512, NULL);
+    if (!pool)
+	return PJ_ENOMEM;
+
+    endpt = pj_pool_zalloc(pool, sizeof(struct pjmedia_endpt));
+    endpt->pool = pool;
+    endpt->pf = pf;
+
+    /* Sound */
+    pj_snd_init(pf);
+
+    /* Init codec manager. */
+    status = pjmedia_codec_mgr_init(&endpt->codec_mgr);
+    if (status != PJ_SUCCESS) {
+	pj_snd_deinit();
+	goto on_error;
+    }
+
+    /* Init and register G.711 codec. */
+    factory = pj_pool_alloc (endpt->pool, sizeof(pjmedia_codec_factory));
+
+    status = g711_init_factory (factory, endpt->pool);
+    if (status != PJ_SUCCESS) {
+	pj_snd_deinit();
+	goto on_error;
+    }
+
+    status = pjmedia_codec_mgr_register_factory (&endpt->codec_mgr, factory);
+    if (status != PJ_SUCCESS)  {
+	pj_snd_deinit();
+	goto on_error;
+    }
+
+    *p_endpt = endpt;
+    return PJ_SUCCESS;
+
+on_error:
+    pj_pool_release(pool);
+    return status;
+}
+
+/**
+ * Get the codec manager instance.
+ */
+PJ_DEF(pjmedia_codec_mgr*) pjmedia_endpt_get_codec_mgr(pjmedia_endpt *endpt)
+{
+    return &endpt->codec_mgr;
+}
+
+/**
+ * Deinitialize media endpoint.
+ */
+PJ_DEF(pj_status_t) pjmedia_endpt_destroy (pjmedia_endpt *endpt)
+{
+    PJ_ASSERT_RETURN(endpt, PJ_EINVAL);
+
+    endpt->pf = NULL;
+
+    pj_snd_deinit();
+    pj_pool_release (endpt->pool);
+
+    return PJ_SUCCESS;
+}
+
+/**
+ * Create pool.
+ */
+PJ_DEF(pj_pool_t*) pjmedia_endpt_create_pool( pjmedia_endpt *endpt,
+					      const char *name,
+					      pj_size_t initial,
+					      pj_size_t increment)
+{
+    pj_assert(endpt != NULL);
+
+    return pj_pool_create(endpt->pf, name, initial, increment, NULL);
+}
+
+/**
+ * Create a SDP session description that describes the endpoint
+ * capability.
+ */
+PJ_DEF(pj_status_t) pjmedia_endpt_create_sdp( pjmedia_endpt *endpt,
+					      pj_pool_t *pool,
+					      unsigned stream_cnt,
+					      const pjmedia_sock_info sock_info[],
+					      pjmedia_sdp_session **p_sdp )
+{
+    pj_time_val tv;
+    unsigned i;
+    pjmedia_sdp_session *sdp;
+    pjmedia_sdp_media *m;
+    pjmedia_sdp_attr *attr;
+
+    PJ_ASSERT_RETURN(endpt && pool && p_sdp && stream_cnt, PJ_EINVAL);
+
+
+    /* Create and initialize basic SDP session */
+    sdp = pj_pool_zalloc (pool, sizeof(pjmedia_sdp_session));
+
+    pj_gettimeofday(&tv);
+    sdp->origin.user = pj_str("-");
+    sdp->origin.version = sdp->origin.id = tv.sec + 2208988800UL;
+    sdp->origin.net_type = STR_IN;
+    sdp->origin.addr_type = STR_IP4;
+    sdp->origin.addr = *pj_gethostname();
+    sdp->name = STR_SDP_NAME;
+
+    /* Since we only support one media stream at present, put the
+     * SDP connection line in the session level.
+     */
+    sdp->conn = pj_pool_zalloc (pool, sizeof(pjmedia_sdp_conn));
+    sdp->conn->net_type = STR_IN;
+    sdp->conn->addr_type = STR_IP4;
+    pj_strdup2(pool, &sdp->conn->addr, 
+	       pj_inet_ntoa(sock_info[0].rtp_addr_name.sin_addr));
+
+
+    /* SDP time and attributes. */
+    sdp->time.start = sdp->time.stop = 0;
+    sdp->attr_count = 0;
+
+    /* Create media stream 0: */
+
+    sdp->media_count = 1;
+    m = pj_pool_zalloc (pool, sizeof(pjmedia_sdp_media));
+    sdp->media[0] = m;
+
+    /* Standard media info: */
+    pj_strdup(pool, &m->desc.media, &STR_AUDIO);
+    m->desc.port = pj_ntohs(sock_info[0].rtp_addr_name.sin_port);
+    m->desc.port_count = 1;
+    pj_strdup (pool, &m->desc.transport, &STR_RTP_AVP);
+
+    /* Add format and rtpmap for each codec. */
+    m->desc.fmt_count = 0;
+    m->attr_count = 0;
+
+    for (i=0; i<endpt->codec_mgr.codec_cnt; ++i) {
+
+	pjmedia_codec_info *codec_info = &endpt->codec_mgr.codecs[i];
+	pjmedia_sdp_rtpmap rtpmap;
+	pjmedia_sdp_attr *attr;
+	pj_str_t *fmt = &m->desc.fmt[m->desc.fmt_count++];
+
+	fmt->ptr = pj_pool_alloc(pool, 8);
+	fmt->slen = pj_utoa(codec_info->pt, fmt->ptr);
+
+	rtpmap.pt = *fmt;
+	rtpmap.clock_rate = codec_info->sample_rate;
+	rtpmap.enc_name = codec_info->encoding_name;
+	rtpmap.param.slen = 0;
+
+	pjmedia_sdp_rtpmap_to_attr(pool, &rtpmap, &attr);
+	m->attr[m->attr_count++] = attr;
+
+    }
+
+    /* Add sendrect attribute. */
+    attr = pj_pool_zalloc(pool, sizeof(pjmedia_sdp_attr));
+    attr->name = STR_SENDRECV;
+    m->attr[m->attr_count++] = attr;
+
+
+    /* Done */
+    *p_sdp = sdp;
+
+    return PJ_SUCCESS;
+
+}
+
Index: pjproject/trunk/pjmedia/src/pjmedia/errno.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/errno.c	(revision 158)
+++ pjproject/trunk/pjmedia/src/pjmedia/errno.c	(revision 159)
@@ -77,4 +77,13 @@
     { PJMEDIA_SDP_ENAMENOTEQUAL,    "SDP name/subject line not equal" },
     { PJMEDIA_SDP_ETIMENOTEQUAL,    "SDP time line not equal" },
+
+    /* Codec errors. */
+    { PJMEDIA_CODEC_EUNSUP,	    "Unsupported media codec" },
+
+    /* Media errors. */
+    { PJMEDIA_EINVALIDIP,	    "Invalid remote media (IP) address" },
+    { PJMEDIA_EASYMCODEC,	    "Asymetric media codec is not supported" },
+    { PJMEDIA_EINVALIDPT,	    "Invalid media payload type" },
+    { PJMEDIA_EMISSINGRTPMAP,	    "Missing rtpmap in media description" },
 };
 
